module Pagseguro
  module Charge
    class Link
      attr_accessor :rel,
                    :href,
                    :media,
                    :type


      def initialize
      end

      def to_json(*options)
        hash = as_json(*options)
        hash.reject! {|k,v| v.nil?}
        hash.to_json(*options)
      end

      def self.fill_from_json(data)
        return if data.nil?

        link = new
        link.rel = data["rel"]
        link.href = data["href"]
        link.media = data["media"]
        link.type = data["type"]
        link
      end

      def as_json(options={})
        {
          rel: @rel,
          href: @href,
          media: @media,
          type: @type
        }
      end

      def pdf?
        @media == 'application/pdf'
      end

      def image?
        @media == 'application/image'
      end

      def json?
        @media == 'application/json'
      end
    end

  end
end